svn commit: r307627 - user/pho/stress2/misc
Peter Holm
pho at FreeBSD.org
Wed Oct 19 11:21:25 UTC 2016
Author: pho
Date: Wed Oct 19 11:21:23 2016
New Revision: 307627
URL: https://svnweb.freebsd.org/changeset/base/307627
Log:
Added regression tests.
Sponsored by: Dell EMC Isilon
Added:
user/pho/stress2/misc/gnop2.sh (contents, props changed)
user/pho/stress2/misc/gnop3.sh (contents, props changed)
Added: user/pho/stress2/misc/gnop2.sh
==============================================================================
--- /dev/null 00:00:00 1970 (empty, because file is newly added)
+++ user/pho/stress2/misc/gnop2.sh Wed Oct 19 11:21:23 2016 (r307627)
@@ -0,0 +1,81 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2016 Dell EMC
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+# "panic: vnode_pager_generic_getpages: sector size 8192 too large" seen
+# with an 8k sector size:
+# https://people.freebsd.org/~pho/stress/log/gnop2.txt
+# Fixed by r307626
+
+. ../default.cfg
+
+kldstat | grep -q geom_nop || { gnop load 2>/dev/null || exit 0 &&
+ notloaded=1; }
+dir=/tmp
+odir=`pwd`
+cd $dir
+sed '1,/^EOF/d' < $odir/mmap5.sh > $dir/gnop2.c
+mycc -o gnop2 -Wall -Wextra gnop2.c || exit 1
+rm -f gnop2.c
+cd $odir
+
+test() {
+ . ../default.cfg
+
+ mount | grep $mntpoint | grep -q /dev/md && umount -f $mntpoint
+ [ -c /dev/md$mdstart ] && mdconfig -d -u $mdstart
+
+ mdconfig -a -t swap -s 2g -u $mdstart || exit 1
+ gnop create -S $1 /dev/md$mdstart
+ newfs $newfs_flags /dev/md${mdstart}.nop > /dev/null
+ mount /dev/md${mdstart}.nop $mntpoint
+ chmod 777 $mntpoint
+
+ dd if=/dev/zero of=$mntpoint/file bs=1k count=333 2>&1 | \
+ egrep -v "records|transferred"
+ /tmp/gnop2 $mntpoint/file
+
+ while mount | grep $mntpoint | grep -q /dev/md; do
+ umount $mntpoint || sleep 1
+ done
+ gnop destroy /dev/md${mdstart}.nop
+ mdconfig -d -u $mdstart
+}
+
+gnop status || exit
+
+for i in 1k 2k 4k 8k; do
+ test $i
+done
+
+[ $notloaded ] && gnop unload
+rm -f /tmp/gnop2
+exit 0
Added: user/pho/stress2/misc/gnop3.sh
==============================================================================
--- /dev/null 00:00:00 1970 (empty, because file is newly added)
+++ user/pho/stress2/misc/gnop3.sh Wed Oct 19 11:21:23 2016 (r307627)
@@ -0,0 +1,69 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2016 Dell EMC
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+# A 8k sector size test.
+# "panic: run 8 0xfffff80ff3d1e040 invalid" seen during fix development.
+
+. ../default.cfg
+
+[ $((`sysctl -n vm.swap_total` / 1024 / 1024 / 1024)) -lt 9 ] && exit 0
+
+kldstat | grep -q geom_nop || { gnop load 2>/dev/null || exit 0 &&
+ notloaded=1; }
+gnop status || exit
+
+mount | grep $mntpoint | grep -q /dev/md && umount -f $mntpoint
+[ -c /dev/md$mdstart ] && mdconfig -d -u $mdstart
+
+mdconfig -a -t swap -s 8g -u $mdstart || exit 1
+gnop create -S 8k /dev/md$mdstart
+newfs $newfs_flags /dev/md${mdstart}.nop > /dev/null
+mount /dev/md${mdstart}.nop $mntpoint
+chmod 777 $mntpoint
+
+cp -a ../../stress2 $mntpoint
+here=`pwd`
+cd $mntpoint/stress2/misc
+
+export runRUNTIME=20m
+export RUNDIR=$mntpoint/stressX
+
+su $testuser -c 'cd ..; ./run.sh marcus.cfg'
+
+cd $here
+while mount | grep $mntpoint | grep -q /dev/md; do
+ umount $mntpoint || sleep 1
+done
+gnop destroy /dev/md${mdstart}.nop
+mdconfig -d -u $mdstart
+[ $notloaded ] && gnop unload
+exit 0
More information about the svn-src-user
mailing list